searchNodes=[{"doc":"Wireguardex is an Elixir library for configuring WireGuard interfaces. It uses Rust NIFs for performance and safety. This is the main module, providing the API for interface configuration and utilities such as key generation.","ref":"Wireguardex.html","title":"Wireguardex","type":"module"},{"doc":"Add a peer to a Device . Returns :ok if successful. {:error, error_info} will be returned if adding the peer to the device fails.","ref":"Wireguardex.html#add_peer/2","title":"Wireguardex.add_peer/2","type":"function"},{"doc":"Delete a Device by its interface name. Returns :ok if successful. {:error, error_info} will be returned if deleting the device fails.","ref":"Wireguardex.html#delete_device/1","title":"Wireguardex.delete_device/1","type":"function"},{"doc":"Generates a random preshared key. It is returned as a base64 string.","ref":"Wireguardex.html#generate_preshared_key/0","title":"Wireguardex.generate_preshared_key/0","type":"function"},{"doc":"Generates a random private key. It is returned as a base64 string.","ref":"Wireguardex.html#generate_private_key/0","title":"Wireguardex.generate_private_key/0","type":"function"},{"doc":"Get a Device by its interface name. Returns Device if successful. {:error, error_info} will be returned if getting the device fails.","ref":"Wireguardex.html#get_device/1","title":"Wireguardex.get_device/1","type":"function"},{"doc":"Return a private key's public key as a base64 string.","ref":"Wireguardex.html#get_public_key/1","title":"Wireguardex.get_public_key/1","type":"function"},{"doc":"Get a list of interfaces from wireguard. Returns [...] if successful. {:error, error_info} will be returned if listing the devices fails.","ref":"Wireguardex.html#list_devices/0","title":"Wireguardex.list_devices/0","type":"function"},{"doc":"Remove a peer from a Device by the peer's public key. Returns :ok if successful. {:error, error_info} will be returned if removing the peer from the device fails.","ref":"Wireguardex.html#remove_peer/2","title":"Wireguardex.remove_peer/2","type":"function"},{"doc":"Set a Device by its interface name using a DeviceConfig . Note if no device is present, a new one will be created for the given interface name. Returns :ok if successful. {:error, error_info} will be returned if setting the device fails.","ref":"Wireguardex.html#set_device/2","title":"Wireguardex.set_device/2","type":"function"},{"doc":"Device represents all available information about a WireGuard device (interface). This struct contains the current configuration of the interface and the current configuration and info for all of its peers. name The interface name of the device. public_key The public encryption key of the interface. private_key The private encryption key of the interface. fwmark The fwmark of this interface. listen_port The port to listen for incoming connections. peers The list of all peers registered to this interface with their configs and stats. linked_name The associated &quot;real&quot; name of the interface.","ref":"Wireguardex.Device.html","title":"Wireguardex.Device","type":"module"},{"doc":"This module contains functions to create a DeviceConfig which itself represents a configuration that can be set on a Wireguard device (interface). If an interface exists, the configuration is applied on top of the existing interface's settings. Missing settings are not overwritten or set to defaults. To crate the default config use device_config/0 then you can apply each function in this module to specify the details. Examples iex&gt; res = ...&gt; device_config ( ) ...&gt; |&gt; listen_port ( 1234 ) ...&gt; |&gt; fwmark ( 11111 ) ...&gt; |&gt; Wireguardex . set_device ( &quot;wg1234&quot; ) ...&gt; Wireguardex . delete_device ( &quot;wg1234&quot; ) ...&gt; res :ok","ref":"Wireguardex.DeviceConfigBuilder.html","title":"Wireguardex.DeviceConfigBuilder","type":"module"},{"doc":"Creates the default configuration to be then configured with the provided functions.","ref":"Wireguardex.DeviceConfigBuilder.html#device_config/0","title":"Wireguardex.DeviceConfigBuilder.device_config/0","type":"function"},{"doc":"The fwmark to set on the interface.","ref":"Wireguardex.DeviceConfigBuilder.html#fwmark/2","title":"Wireguardex.DeviceConfigBuilder.fwmark/2","type":"function"},{"doc":"The listening port for incoming connections to set on the interface.","ref":"Wireguardex.DeviceConfigBuilder.html#listen_port/2","title":"Wireguardex.DeviceConfigBuilder.listen_port/2","type":"function"},{"doc":"A list of peers with their own configurations to set on this interface.","ref":"Wireguardex.DeviceConfigBuilder.html#peers/2","title":"Wireguardex.DeviceConfigBuilder.peers/2","type":"function"},{"doc":"The private encryption key to set on the interface.","ref":"Wireguardex.DeviceConfigBuilder.html#private_key/2","title":"Wireguardex.DeviceConfigBuilder.private_key/2","type":"function"},{"doc":"The public encryption key to set on the interface.","ref":"Wireguardex.DeviceConfigBuilder.html#public_key/2","title":"Wireguardex.DeviceConfigBuilder.public_key/2","type":"function"},{"doc":"If true, replace existing peer configurations on the interface.","ref":"Wireguardex.DeviceConfigBuilder.html#replace_peers/2","title":"Wireguardex.DeviceConfigBuilder.replace_peers/2","type":"function"},{"doc":"This module contains functions to create a PeerConfig which represents a peer's configuration of persistent attributes. They do not change over time and are part of the configuration of a device. To create the defualt config use peer_config/0 then you can apply each function in this module to specify the config. Examples iex&gt; res = ...&gt; device_config ( ) ...&gt; |&gt; peers ( [ ...&gt; peer_config ( ) ...&gt; |&gt; Wireguardex.PeerConfigBuilder . public_key ( Wireguardex . get_public_key ( Wireguardex . generate_private_key ( ) ) ) ...&gt; |&gt; endpoint ( &quot;127.0.0.1:1234&quot; ) ...&gt; |&gt; preshared_key ( Wireguardex . generate_preshared_key ( ) ) ...&gt; |&gt; persistent_keepalive_interval ( 60 ) ...&gt; |&gt; allowed_ips ( [ &quot;127.0.0.1/16&quot; ] ) ...&gt; ] ) ...&gt; |&gt; Wireguardex . set_device ( &quot;wg12345&quot; ) ...&gt; Wireguardex . delete_device ( &quot;wg12345&quot; ) ...&gt; res :ok","ref":"Wireguardex.PeerConfigBuilder.html","title":"Wireguardex.PeerConfigBuilder","type":"module"},{"doc":"The allowed ip addresses this peer is allowed to have.","ref":"Wireguardex.PeerConfigBuilder.html#allowed_ips/2","title":"Wireguardex.PeerConfigBuilder.allowed_ips/2","type":"function"},{"doc":"The endpoint this peer listens for connections on ( nil means any).","ref":"Wireguardex.PeerConfigBuilder.html#endpoint/2","title":"Wireguardex.PeerConfigBuilder.endpoint/2","type":"function"},{"doc":"Creates the default peer configuration that you can then specify which each of the provided functions.","ref":"Wireguardex.PeerConfigBuilder.html#peer_config/0","title":"Wireguardex.PeerConfigBuilder.peer_config/0","type":"function"},{"doc":"The interval for sending keepalive packets ( nil means disabled).","ref":"Wireguardex.PeerConfigBuilder.html#persistent_keepalive_interval/2","title":"Wireguardex.PeerConfigBuilder.persistent_keepalive_interval/2","type":"function"},{"doc":"The preshared key available to both peers ( nil means no PSK is used).","ref":"Wireguardex.PeerConfigBuilder.html#preshared_key/2","title":"Wireguardex.PeerConfigBuilder.preshared_key/2","type":"function"},{"doc":"The public key of the peer.","ref":"Wireguardex.PeerConfigBuilder.html#public_key/2","title":"Wireguardex.PeerConfigBuilder.public_key/2","type":"function"},{"doc":"PeerInfo represents all of the available information of a peer. This struct is a simple pair of a peer's configuration and stats. config The configuration belonging to this peer. stats The current statistics of this peer.","ref":"Wireguardex.PeerInfo.html","title":"Wireguardex.PeerInfo","type":"module"},{"doc":"PeerStats represent a peer's statistics from the current session. These are the attributes of a peer that will change over time; to get updated stats re-read the information from the interface. last_handshake_time Timestamp of the last handshake/rekey with this peer. rx_bytes Number of bytes received from this peer. tx_bytes Number of bytes transmitted to this peer.","ref":"Wireguardex.PeerStats.html","title":"Wireguardex.PeerStats","type":"module"},{"doc":"An Elixir library for configuring WireGuard interfaces via NIFs implemented in Rust .","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding wireguardex to your list of dependencies in mix.exs : def deps do [ { :wireguardex , &quot;~&gt; 0.1.1&quot; } ] end Wireguardex will try to download a precompiled NIF library. If you want to compile your own NIF, you'll need to have Rust installed. The common option is to use Rustup . To force compiliation you can set the environment variable WIREGUARDNIF_BUILD to true or 1 . Or you can set the application env to force the NIF to compile: config :ruslter_precompiled , :force_build , wireguardex : true","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Running the tests will also require a Rust installation, as the NIF is compiled locally before running the tests.","ref":"readme.html#tests","title":"Overview - Tests","type":"extras"}]